SystemOrganization addCategory: #TOcurricula!

Object subclass: #Consultor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 10:14'!
cargarDataFile: arc
	"En esta funcion vamos a abrir el file que contiene la informacion que se graficara
	y se devolver la matriz o array que contiene la informacion de los cursos"
	| arch col stream1 stream2 mat data cad |
	arch := FileStream fileNamed: arc.
	mat := OrderedCollection new.
	data := OrderedCollection new.
	stream1 := (arch contentsOfEntireFile) readStream .
	stream2 := (arch contentsOfEntireFile) readStream .
	[stream1 atEnd not & stream2 atEnd not] whileTrue: [
		stream1 skipTo: $%.	"encuentra el simbolo de separacion"
		cad := stream2 next: ((stream1 position - stream2 position )- 1).
		mat add: cad asString. 
		stream2 next. 	"avanza una posicion despues del simbolo de separacion para leer la nueva palabra"
		(stream2 peek = $#) ifTrue: [ stream2 next. data add: mat. mat := OrderedCollection new. ]
	].
	^data.! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 10:27'!
cargarDataUrl: nomLink
	| data jsonObject subs tam |
	jsonObject := self conectarTo: nomLink.
	data := OrderedCollection new.
	subs :=	jsonObject at: 'feed'.
	subs := subs at: 'entry'.
	tam := subs size .
	1 to: tam do: [:pos | 
		| mat | 
		mat := OrderedCollection new.
		mat add: (((subs at: pos) at: 'gsx$codigo') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$nombre') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$cred') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq1') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq2') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq3') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$prereq4') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrstotal') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrsteoria') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrsprac') at: '$t').
		mat add: (((subs at: pos) at: 'gsx$hrsteoprac') at: '$t').
		
		data add: mat.
	].
	^data! !

!Consultor methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 10:11'!
conectarTo: cad
	| dir parser jsonObject json subs root|
	(cad ~= '') ifTrue: [dir := cad] 
		ifFalse: [dir := 'http://spreadsheets.google.com/feeds/list/0AjE_p7Re6WDHdEJKUEVIM0dLWlY1TjRPZnQ1ZnVyVGc/od6/public/values?alt=json'].		
	parser := PPParserResource current parserAt: PPJsonParser.
	json := (Url absoluteFromText: dir) retrieveContents contents.
	jsonObject := parser parse: json.
	^jsonObject 
! !

Object subclass: #Visualizador
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TOcurricula'!

!Visualizador methodsFor: 'as yet unclassified' stamp: 'AngelaMayhuaQuispe 11/9/2012 10:48'!
mostrarFrom: nomSource
	|view cursos cabecera tam cod |
	cursos := Consultor new cargarDataUrl: nomSource.		"Cargamos la matriz de los cursos que tenemos almacenados"
	view := MOViewRenderer new.
	view nodes: cursos forEach: [:cls |  
		cod := cls first .
		view interaction forward.
		view shape label.
		view node: cod.
	].
	tam := cursos size.
	1 to: tam do: [:i |
		4 to: 7 do: [:j |
			| ant |
			cod := (cursos at: i) at: j.
			(cod = '') ifFalse: [
				view edges: {(cod) -> ((cursos at: i) first) } from: #key to: #value ]
		]
	].
	view treeLayout. 
	view open ! !
